/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, typeCast, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, delegateCombine, fromEnum, markDep } from "igniteui-react-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-react-core";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Pool$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { DoubleCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { round10N } from "igniteui-react-core";
/**
 * @hidden
 */
var CategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryBucketCalculator, _super);
    function CategoryBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.e = 0;
        _this.f = 0;
        _this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.c = a;
        _this.e = -1;
        _this.d = 0;
        return _this;
    }
    CategoryBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    CategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    CategoryBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    CategoryBucketCalculator.prototype.g = function (a) {
        var b = this.c.by;
        var c = this.c.bx;
        var d = this.c.cw;
        var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        var f = d.c6;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        var g = d.getEffectiveViewport1(this.c);
        var h = d.to(this.c);
        var i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            var j = new ScalerParams(0, b, c, e.ch, g);
            var k = Math.floor(e.em(h.left, j));
            var l = Math.ceil(e.em(h.right, j));
            if (e.ch) {
                l = Math.ceil(e.em(h.left, j));
                k = Math.floor(e.em(h.right, j));
            }
            l = Math.min(l, e.lg - 1);
            var m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    };
    CategoryBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.cw.hj;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    CategoryBucketCalculator.prototype.cacheValues = function () {
    };
    CategoryBucketCalculator.prototype.unCacheValues = function () {
    };
    CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
}(Base));
export { CategoryBucketCalculator };
/**
 * @hidden
 */
var CategoryFramePreparerBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryFramePreparerBase, _super);
    function CategoryFramePreparerBase(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, g, h, i) || this;
                        _this.g = null;
                        _this.h = null;
                        _this.m = false;
                        _this.o = new List$1(Array_$type, 0);
                        _this.p = new List$1(Number_$type, 0);
                        _this.n = new List$1(Number_$type, 0);
                        _this.h = f;
                        _this.g = j;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, d, e, f) || this;
                    _this.g = null;
                    _this.h = null;
                    _this.m = false;
                    _this.o = new List$1(Array_$type, 0);
                    _this.p = new List$1(Number_$type, 0);
                    _this.n = new List$1(Number_$type, 0);
                    _this.h = c;
                    _this.g = g;
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparerBase.prototype.i = function (a) {
        var b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        var c;
        var d;
        var e;
        var f;
        var g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.k = c;
        b.l = d;
        b.j = e;
        b.i = f;
        if (b.l < b.k) {
            return null;
        }
        var h;
        var i;
        var j;
        var k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        var l = this.a.getMainContentViewport();
        b.p = h;
        b.o = i;
        b.n = j;
        b.m = l;
        if (Rect.l_op_Equality(b.p, Rect.empty) || Rect.l_op_Equality(b.o, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.ep) && this.g != null) {
            b.e = true;
        }
        return b;
    };
    CategoryFramePreparerBase.prototype.r = function (a, b, c, d) {
        return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    };
    CategoryFramePreparerBase.prototype.s = function (a) {
        return this.r(a.b, a.p, a.o, a.n);
    };
    CategoryFramePreparerBase.prototype.d = function (a, b) {
        var c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.m.clear();
        c.a.p.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        var d = this.c.shouldDisplayMarkers;
        var e = false;
        var f = this.s(c);
        var g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            var h = c.d.i$b._inner[c.k];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.k > 0) {
                c.k = c.k - 1;
                h = c.d.i$b._inner[c.k];
                this.z(g, h, true, c.e);
            }
            var i = c.d.i$b._inner[c.l];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.l < g.e - 1) {
                c.l = c.l + 1;
                i = c.d.i$b._inner[c.l];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            var j = c.k;
            var k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.k > 0) {
                c.k = c.k - 1;
                j = c.k;
                k = this.g.getBucket(j);
            }
            var l = c.l;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.l < (intDivide(g.e, c.j))) {
                c.l = c.l + 1;
                l = c.l;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        var m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    };
    CategoryFramePreparerBase.prototype.v = function (a, b) {
    };
    Object.defineProperty(CategoryFramePreparerBase.prototype, "q", {
        get: function () {
            return this.o;
        },
        enumerable: false,
        configurable: true
    });
    CategoryFramePreparerBase.prototype.t = function (a, b, c, d, e) {
        var _this = this;
        var f = 0;
        var g = false;
        var h = null;
        var i = false;
        var j = a.d != null;
        var k = a.p;
        var l = a.o;
        var m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.lj;
        var n = a.f;
        var o = this.h.mayContainUnknowns;
        var p = this.o;
        var q = this.n;
        var r = this.p;
        p.clear();
        q.clear();
        r.clear();
        var s = this.g;
        var t = this.h.provideCollisionDetector();
        var u = 0;
        var v = a.n;
        var w = new ScalerParams(0, k, l, a.b.j$b, v);
        var x = ((function () {
            var $ret = new ScalerParams(0, k, l, a.c.j$b, v);
            $ret.b = typeCast(Series.$, _this.h) !== null ? _this.h.h2() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$d(2, w) - a.b.j$d(1, w);
            i = this.k();
        }
        var y = a.k;
        var z = a.l;
        var aa = a.a.f;
        var ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        var _loop_1 = function (ac) {
            var ad = void 0;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((function () { var ae = _this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            var ae = !m || (m && ad[1] > 0);
            var af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                    }
                }
                if (d && ae) {
                    var ag = ac * a.j;
                    var ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    var ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this_1.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
            out_ac_1 = ac;
        };
        var this_1 = this, out_ac_1;
        for (var ac = y; ac <= z; ++ac) {
            _loop_1(ac);
            ac = out_ac_1;
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            var aj = p.count;
            var ak = void 0;
            for (var al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    };
    CategoryFramePreparerBase.prototype.k = function () {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.d9;
        }
        return false;
    };
    CategoryFramePreparerBase.prototype.f = function (a, b, c, d, e, f, g) {
        var h;
        f = null;
        e = false;
        var i = typeCast(CategorySeries.$, this.h);
        var j = a.o;
        var k = a.p;
        var l = a.n;
        var m = new ScalerParams(0, k, j, a.b.j$b, l);
        var n = new ScalerParams(0, k, j, a.c.j$b, l);
        var o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.c6 != null && i.c6.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        var p = a.d.i$b._inner[b];
        var q = a.d.i$d(p);
        var r = q;
        this.z(c, p, false, o);
        while (b < a.l) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    var s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$c(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                var t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                var u = [a.b.j$c(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        var v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$c(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    };
    CategoryFramePreparerBase.prototype.y = function (a, b, c, d, e, f, g) {
        var h = a.j;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.o;
        var l = k.count;
        if (f) {
            var m = a.c.j$c(a.c.l7, e);
            a.c.j$f(a.a.k, 0, a.a.k.count, e);
            var n = a.a.k;
            var o = n.count;
            for (var p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    };
    CategoryFramePreparerBase.prototype.w = function (a, b, c) {
    };
    CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
}(FramePreparer));
export { CategoryFramePreparerBase };
/**
 * @hidden
 */
var CategoryFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryFramePreparer, _super);
    function CategoryFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, f, g, h, i, j) || this;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        _this.ab = new DefaultSingleValueProvider();
                        _this.ac = null;
                        _this.ad = null;
                        _this.ac = _this.aa;
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            _this.ac = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        _this.ad = _this.ab;
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            _this.ad = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                    _this.aa = new DefaultCategoryTrendlineHost();
                    _this.ab = new DefaultSingleValueProvider();
                    _this.ac = null;
                    _this.ad = null;
                    _this.ac = _this.aa;
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        _this.ac = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    _this.ad = _this.ab;
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        _this.ad = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[0];
        var h = b[1];
        var i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    CategoryFramePreparer.prototype.j = function (a) {
        var b = new SingleValuesHolder();
        var c = this.ad.valueColumn;
        b.f = c;
        return b;
    };
    CategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$c(b[0], e) + c;
        }
        b[1] = a.c.j$c(b[1], f);
        if (a.j > 1 || d) {
            b[2] = a.c.j$c(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    };
    CategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
        _super.prototype.y.call(this, a, b, c, d, e, f, g);
        var h = a.j;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.q;
        var l = k.count;
        var m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        var n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$e(j, m, 0, i, d);
        a.c.j$e(j, n, 0, i, e);
        for (var o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (var p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$e(k, m, 0, l, d);
            a.c.j$e(k, n, 0, l, e);
            for (var q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (var r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    };
    CategoryFramePreparer.prototype.w = function (a, b, c) {
        if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
            return;
        }
        this.ac.trendlinePreparer.prepareLine(this.ac, a, b, c);
    };
    CategoryFramePreparer.prototype.z = function (a, b, c, d) {
        var e = a;
        var f = e.f;
        var g = f.item(b);
        var h = g;
        if (d) {
            var i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    };
    CategoryFramePreparer.prototype.u = function (a, b, c) {
        var d = a;
        var e = d.f;
        if (b < e.count) {
            var f = void 0;
            if (c) {
                var g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    };
    CategoryFramePreparer.prototype.e = function (a, b) {
        var c = b;
        return [a, c.a, c.b];
    };
    CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
}(CategoryFramePreparerBase));
export { CategoryFramePreparer };
/**
 * @hidden
 */
var CategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeries, _super);
    function CategorySeries() {
        var _this = _super.call(this) || this;
        _this.vr = null;
        _this.v4 = null;
        _this.v8 = false;
        _this.v7 = false;
        _this.assigningCategoryStyle = null;
        _this.assigningCategoryMarkerStyle = null;
        _this.v2 = null;
        _this.v3 = null;
        _this.vo = new CategoryFrame(3);
        _this.vq = new CategoryFrame(3);
        _this.vm = new CategoryFrame(3);
        _this.vp = new CategoryFrame(3);
        _this.vu = null;
        _this.vy = null;
        _this.vu = new CategorySeriesRenderManager();
        _this.vy = new CategoryTransitionSourceFramePreparer();
        _this.v8 = false;
        _this.v7 = false;
        _this.ab = CategorySeries.$;
        return _this;
    }
    CategorySeries.prototype.cg = function () {
        var a = new CategorySeriesView(this);
        return a;
    };
    Object.defineProperty(CategorySeries.prototype, "v5", {
        get: function () {
            var _this = this;
            if (this.v4 == null) {
                this.v4 = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, function () { return _this.c9.n; });
            }
            return this.v4;
        },
        enumerable: false,
        configurable: true
    });
    CategorySeries.prototype.ds = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.getEffectiveViewport1(this.cj);
        var f = this.vl();
        var g = new ScalerParams(1, this.cy.tn, this.tw, f.ch);
        g.c = e;
        var h = this.v6();
        var i = new ScalerParams(1, this.cy.tn, this.tw, h.ch);
        i.c = e;
        var j = this.cy.tn;
        var k = this.tw;
        var l = this.currentMode2Index;
        var m = 0;
        if (f.ce && f.cc) {
            m = f.getSeriesOffset(j, k, e, l, f.categoryMode);
        }
        a.clear();
        this.t9.ci(function (n) {
            if (n._visibility == 0) {
                var o = new SeriesPointOfInterest();
                var p = n.n;
                var q = n.o;
                if (p < _this.tw.left || p > _this.tw.right || q < _this.tw.top || q > _this.tw.bottom) {
                    return;
                }
                if (_this.isVertical) {
                    if (f.cb && !f.ce && f.categoryMode != 0) {
                        o.c = n.ak;
                    }
                    else {
                        o.c = f.em(q, g);
                    }
                    o.b = h.em(p, i);
                }
                else {
                    if (f.cb && !f.ce && f.categoryMode != 0) {
                        o.b = n.ak;
                    }
                    else {
                        o.b = f.em(p, g);
                    }
                    o.c = h.em(q, i);
                }
                o.a = n.content;
                if (b) {
                    if (_this.isVertical) {
                        if (c) {
                            o.d = _this.wr(o.b, d);
                        }
                        else {
                            var r = _this.ih(n);
                            if (!isNaN_(r)) {
                                o.d = _this.wr(r, d);
                            }
                            else {
                                o.d = _this.wr(o.b, d);
                            }
                        }
                    }
                    else {
                        if (c) {
                            o.d = _this.wr(o.c, d);
                        }
                        else {
                            var s = _this.ih(n);
                            if (!isNaN_(s)) {
                                o.d = _this.wr(s, d);
                            }
                            else {
                                o.d = _this.wr(o.c, d);
                            }
                        }
                    }
                }
                else {
                    o.d = f.gd(n.ak);
                }
                a.add(o);
            }
        });
        return true;
    };
    CategorySeries.prototype.wr = function (a, b) {
        if (b >= 0) {
            return round10N(a, b).toString();
        }
        else {
            return a.toString();
        }
    };
    CategorySeries.prototype.o0 = function (a) {
        _super.prototype.o0.call(this, a);
        this.vv = a;
    };
    CategorySeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(CategorySeries.prototype, "categoryAxis", {
        get: function () {
            return this.vl();
        },
        enumerable: false,
        configurable: true
    });
    CategorySeries.prototype.vl = function () {
        return this.fetchXAxis();
    };
    CategorySeries.prototype.v6 = function () {
        return this.fetchYAxis();
    };
    CategorySeries.prototype.get_dz = function () {
        return true;
    };
    CategorySeries.prototype.get_fi = function () {
        return this.v6() != null && this.v6().ch;
    };
    CategorySeries.prototype.get_ec = function () {
        return true;
    };
    CategorySeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.vv.cu.g(this.hj);
    };
    CategorySeries.prototype.we = function () {
        return (this.assigningCategoryStyle != null && this.v8) || (this.bs != 1);
    };
    CategorySeries.prototype.wf = function () {
        return (this.assigningCategoryMarkerStyle != null && this.v7) || (this.bs != 1);
    };
    CategorySeries.prototype.w4 = function (a) {
        if (this.assigningCategoryStyle != null && this.v8) {
            this.assigningCategoryStyle(this, a);
        }
    };
    CategorySeries.prototype.w3 = function (a) {
        if (this.assigningCategoryMarkerStyle != null && this.v7) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    };
    CategorySeries.prototype.vf = function (a, b) {
        return null;
    };
    CategorySeries.prototype.nj = function (a, b) {
        _super.prototype.nj.call(this, a, b);
        if (a) {
            this.wy(b);
        }
    };
    CategorySeries.prototype.bm = function () {
        var a = _super.prototype.bm.call(this);
        return a;
    };
    CategorySeries.prototype.ob = function () {
        _super.prototype.ob.call(this);
        var a = this.fetchXAxis();
        if (a != null) {
            a.h8(false);
        }
        var b = this.fetchYAxis();
        if (b != null) {
            b.h8(false);
        }
    };
    CategorySeries.prototype.qn = function (a, b) {
        _super.prototype.qn.call(this, a, b);
        this.vv.cu.g(this.hj);
        this.pp(false);
    };
    CategorySeries.prototype.qm = function (a, b) {
        if (this.f9 && this.iv < 0.05 && (this.cy == null || !this.cy.ew())) {
            this.ga = true;
            this.gd = false;
            this.ft = false;
        }
        _super.prototype.qm.call(this, a, b);
        this.vv.cu.g(this.hj);
        this.pp(false);
    };
    CategorySeries.prototype.o8 = function (a, b, c, d) {
        _super.prototype.o8.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = this.fetchYAxis();
                var f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.np(f);
                    this.np(e);
                }
                if (c == null && d != null) {
                    this.pf(f);
                    this.pf(e);
                }
                this.vv.cu.g(this.hj);
                this.pp(false);
                break;
            case "SyncLink":
                if (this.cr != null && this.cy != null) {
                    this.vv.cu.g(this.hj);
                }
                this.pp(false);
                break;
            case "TransitionProgress":
                this.vq.c(this.iv, this.vo, this.vm);
                if (this.dl(this.cj)) {
                    return;
                }
                if (this.iv == 1) {
                    this.vm.v();
                    this.w5(this.vm, this.vv);
                    if (this.f9) {
                        this.f9 = false;
                        this.nk();
                        this.cz.r = truncate(this.id());
                        this.cz.b = this.c0;
                    }
                    if (this.gc) {
                        this.gc = false;
                        this.nk();
                        this.cz.r = truncate(this.id());
                        this.cz.b = this.c0;
                        this.oz();
                    }
                }
                else {
                    this.w5(this.vq, this.vv);
                }
                if (this.cy != null) {
                    this.cy.on(this);
                }
                break;
            case "ErrorBarSettings":
                this.ol();
                break;
            case CategorySeries.$$p[4]:
                this.pp(false);
                break;
            case CategorySeries.$$p[1]:
                this.v8 = this.wa();
                this.pp(false);
                break;
            case CategorySeries.$$p[0]:
                this.v7 = this.v9();
                this.pp(false);
                break;
        }
    };
    CategorySeries.prototype.wa = function () {
        return this.wc;
    };
    CategorySeries.prototype.v9 = function () {
        return this.wb;
    };
    CategorySeries.prototype.wl = function (a) {
        return this.hx(a, this.fetchXAxis());
    };
    CategorySeries.prototype.get_e5 = function () {
        return typeCast(ISortingAxis_$type, this.vl()) !== null;
    };
    CategorySeries.prototype.as = function () {
        return this.vl();
    };
    CategorySeries.prototype.ja = function (a) {
        return this.v5.b$d(this, a);
    };
    CategorySeries.prototype.jr = function (a) {
        return this.v5.b$f(this, a);
    };
    CategorySeries.prototype.i8 = function (a) {
        var b = truncate(Math.round(this.hv(a)));
        return b;
    };
    CategorySeries.prototype.hv = function (a) {
        return this.v5.b$c(this, a);
    };
    CategorySeries.prototype.ay = function (a, b, c) {
        if (this.fc(this.bs) && !c) {
            var d = this.v1(a, b, this.v3);
            this.v3 = d;
            return d;
        }
        else {
            var e = this.vz(a, b, this.v3);
            e.e = true;
            this.v3 = e;
            return e;
        }
    };
    CategorySeries.prototype.get_es = function () {
        return true;
    };
    CategorySeries.prototype.nh = function () {
        _super.prototype.nh.call(this);
        this.v2 = null;
        this.v3 = null;
    };
    CategorySeries.prototype.ax = function (a, b, c) {
        if (this.du && this.fc(this.bs) && !c) {
            var d = this.v0(a, b, this.v2);
            this.v2 = d;
            return d;
        }
        else {
            var e = this.vz(a, b, this.v2);
            this.v2 = e;
            return e;
        }
    };
    CategorySeries.prototype.wk = function () {
        return this.vv.cx.a;
    };
    CategorySeries.prototype.v1 = function (a, b, c) {
        if (!this.uc()) {
            return null;
        }
        var d = this.vn();
        var e = this.wk();
        return this.v5.b$b(this, e, this.wo(this.cj), this.wn(this.cj), d.f, a, b, c);
    };
    CategorySeries.prototype.v0 = function (a, b, c) {
        var d = this.wo(this.cj);
        var e = this.wp(this.cj);
        var f = this.wn(this.cj);
        var g = this.vn();
        return this.v5.b$a(this, g.f, d, e, f, a, b, c);
    };
    CategorySeries.prototype.vz = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.c6 != null ? this.c6.count - 1 : 0;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    CategorySeries.prototype.vn = function () {
        var a = this.vm;
        if (this.dj()) {
            if (this.cz.g) {
                this.cz.t();
            }
            a = this.vq;
        }
        return a;
    };
    CategorySeries.prototype.w0 = function (a, b, c, d, e, f) {
        var g = this.bs != 1;
        this.vu.a3(this.vu.d, d.cn, a, b, c, d, e, f, true);
        this.vu.aa(this.hh);
        var h = this.vu.ax;
        var i = null;
        var j = this.c6;
        var k = null;
        if (g && this.cy != null) {
            i = this.cy.a7.getHighlightingInfo(this, j, h.o, h.n, true);
            if (this.cy.a7.isCrossSeriesHighlight(this)) {
                k = this.cy.a7.getHighlightingInfo(this, j, h.o, h.n, true);
            }
            h.b = i;
        }
        h.f = f;
        this.w3(h);
        this.vu.y(this, i, f, g, h.m, this.cy.a7.totalHighlightingProgress);
    };
    CategorySeries.prototype.w1 = function (a, b, c, d, e, f) {
        var g = this.bs != 1;
        this.vu.a3(this.vu.b, d.cn, a, b, c, d, e, f, false);
        this.vu.ab(this.hh);
        var h = this.vu.ay;
        var i = null;
        var j = this.c6;
        if (g && this.cy != null) {
            i = this.cy.a7.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = f;
        this.w4(h);
        this.vu.z(this, i, f, g, b < 0);
    };
    CategorySeries.prototype.gl = function (a, b, c) {
        var d = _super.prototype.gl.call(this, a, b, c);
        d = d && this.wj(this.fetchXAxis());
        d = d && this.wj(this.fetchYAxis());
        var e = c;
        if (!c.o() || b.isEmpty || a.isEmpty || this.c6 == null) {
            d = false;
        }
        if (!d) {
            e.cu.d = 0;
        }
        return d;
    };
    CategorySeries.prototype.wj = function (a) {
        if (a == null || a.bi == null) {
            return false;
        }
        var b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.lf < 1) {
                return false;
            }
        }
        else {
            var c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.lx != c.lw;
            }
        }
        return true;
    };
    CategorySeries.prototype.fw = function () {
        return this.wd;
    };
    CategorySeries.prototype.fx = function () {
        return true;
    };
    CategorySeries.prototype.vw = function () {
        return 12;
    };
    CategorySeries.prototype.nk = function () {
        _super.prototype.nk.call(this);
        this.vo.v();
        this.vm.v();
        this.vq.v();
    };
    CategorySeries.prototype.pq = function (a) {
        _super.prototype.pq.call(this, a);
        this.vv.cu.g(this.hj);
        if (this.dl(this.cj)) {
            this.vm.y();
            this.vq.y();
            this.vo.y();
            return;
        }
        if (this.f0) {
            if (this.dj()) {
                if (this.cz.g) {
                    this.cz.t();
                }
                this.w5(this.vq, this.vv);
            }
            else {
                this.w5(this.vm, this.vv);
            }
            return;
        }
        if (this.fp(a)) {
            var b = this.vo;
            if (this.dj()) {
                if (this.cz.g) {
                    this.cz.t();
                }
                this.vo = this.vq;
                this.vq = b;
            }
            else {
                this.vo = this.vm;
                this.vm = b;
            }
            var c = false;
            this.w2(this.vm, this.vv);
            if (this.gb) {
                this.cz.w();
                this.cz.r = truncate(this.ie());
                this.cz.b = this.c1 != null ? this.c1 : this.c0;
                if (this.gc) {
                    var d = this.vq;
                    this.vq = this.vo;
                    this.vo = d;
                    c = true;
                }
                this.vy.s(this, this.vo, this.vm, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.vx, this.vw(), this.ct, this.cs(), runOn(this, this.wm), this.vv.bx);
                if (this.gc) {
                    var e = this.vq;
                    this.vq = this.vo;
                    this.vo = e;
                }
                this.gc = false;
            }
            if (this.ge) {
                this.cz.w();
                this.cz.r = truncate(this.ig());
                this.cz.b = this.c2 != null ? this.c2 : this.c0;
                if (this.f9) {
                    var f = this.vq;
                    this.vq = this.vo;
                    this.vo = f;
                    c = true;
                }
                this.vy.s(this, this.vo, this.vm, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.vx, this.vw(), this.ct, this.cs(), runOn(this, this.wm), this.vv.bx);
                var g = this.vm;
                this.vm = this.vo;
                this.vo = g;
                if (this.f9) {
                    var h = this.vq;
                    this.vq = this.vo;
                    this.vo = h;
                }
                this.f9 = false;
            }
            this.dq = false;
            if (!c) {
                this.nf();
            }
            this.p3();
            if (this.gb) {
                this.ga = false;
                this.f9 = true;
            }
            if (this.ge) {
                this.gd = false;
                this.gc = true;
            }
        }
        else {
            this.w2(this.vm, this.vv);
            this.w5(this.vm, this.vv);
        }
    };
    CategorySeries.prototype.cs = function () {
        return 3;
    };
    CategorySeries.prototype.cu = function () {
        var a = this.cs();
        switch (a) {
            case 0: return 0;
            case 1: return 1;
            case 4: return 4;
            case 2: return 2;
            case 3: return 3;
        }
        return 3;
    };
    CategorySeries.prototype.wm = function () {
        if (this.isVertical) {
            return this.tw.left;
        }
        return this.tw.bottom;
    };
    CategorySeries.prototype.wg = function () {
        return false;
    };
    CategorySeries.prototype.g0 = function () {
        var a = _super.prototype.g0.call(this);
        if (this.wg()) {
            var b = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "DashArray";
                $ret.p = true;
                $ret.x = ((function () {
                    var $ret = new DoubleCollection();
                    $ret.add(5);
                    $ret.add(5);
                    return $ret;
                })());
                $ret.q = true;
                return $ret;
            })());
            a.add(b);
        }
        if (!this.wg()) {
            var c = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Brush";
                $ret.p = true;
                $ret.y = "ActualBrush";
                $ret.q = true;
                return $ret;
            })());
            c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.px));
            a.add(c);
        }
        if (!this.wg()) {
            var d = ((function () {
                var $ret = new SeriesLayerPropertyOverlay();
                $ret.r = true;
                $ret.ad = "Outline";
                $ret.p = true;
                $ret.y = "ActualOutline";
                $ret.q = true;
                return $ret;
            })());
            d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.px));
            a.add(d);
        }
        var e = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "IsTransitionInEnabled";
            $ret.x = true;
            $ret.q = true;
            return $ret;
        })());
        a.add(e);
        var f = ((function () {
            var $ret = new SeriesLayerPropertyOverlay();
            $ret.p = true;
            $ret.ad = "TransitionInMode";
            $ret.x = enumGetBox(CategoryTransitionInMode_$type, 20);
            $ret.q = true;
            return $ret;
        })());
        a.add(f);
        return a;
    };
    CategorySeries.prototype.jw = function () {
        if (this.dj()) {
            return this.bi.vq;
        }
        else {
            return this.bi.vm;
        }
    };
    CategorySeries.prototype.wq = function () {
        var e_1, _a;
        if (this.bi != null) {
            var a = this.bi;
            return a.wq();
        }
        var b = 0;
        var c = this.fetchXAxis();
        try {
            for (var _b = __values(fromEnum(this.cy.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                if (d == this) {
                    return b;
                }
                var e = typeCast(CategorySeries.$, d);
                if (e != null) {
                    var f = typeCast(CategoryAxisBase.$, e.fetchXAxis());
                    if (f == c && e.preferredCategoryMode(f) == 2) {
                        b++;
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.fetchXAxis();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.fetchYAxis();
        },
        enumerable: false,
        configurable: true
    });
    CategorySeries.prototype.wz = function (a, b) {
        this.vu.a1(this, this.wf(), runOn(this, this.vf), this.wn(a), this.wo(a));
        var c = this.vu.d;
        var d = c != null;
        var e = this.vl();
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.by, a.bx, e.ch, f);
        var h = this.c6 == null ? 0 : this.c6.count;
        var i = a;
        var j = b.f;
        var k = i.cu.e;
        var l = i.cu.f;
        var m = i.cu.d;
        var n = k * m;
        for (var o = 0; o < a.cx.count; o++) {
            var p = a.cx.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.w0(j, r, h, e, g, a.q);
            }
            this.vu.ac(p, q);
        }
    };
    CategorySeries.prototype.w5 = function (a, b) {
        this.ow();
        this.tn = a.aa;
        b.aw();
    };
    CategorySeries.prototype.w2 = function (a, b) {
        a.u();
    };
    CategorySeries.prototype.wn = function (a) {
        return a.cu.d;
    };
    CategorySeries.prototype.wo = function (a) {
        return a.cu.e;
    };
    CategorySeries.prototype.wp = function (a) {
        return a.cu.f;
    };
    CategorySeries.prototype.wy = function (a) {
        var b = a;
        b.cx.count = 0;
    };
    CategorySeries.prototype.pr = function (a, b) {
        _super.prototype.pr.call(this, a, b);
        if (!this.f8) {
            this.cj.a4(b);
            return;
        }
        var c = typeCast(CategorySeriesView.$, this.ci);
        c.cu.g(this.hj);
        this.cj.a4(b);
        if (this.dl(this.ci)) {
            return;
        }
        this.w6();
        this.f8 = false;
    };
    CategorySeries.prototype.w6 = function () {
        var a = typeCast(CategorySeriesView.$, this.ci);
        if (!this.f1) {
            this.w2(this.vp, a);
        }
        this.f1 = false;
        this.w5(this.vp, a);
    };
    CategorySeries.prototype.vs = function (a) {
        var b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.q) {
            if (b.p) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cu);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.cy.cv.o, this, b.cu);
            }
        }
        else {
            return this.vr;
        }
    };
    CategorySeries.prototype.ao = function (a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    };
    CategorySeries.prototype.ag = function () {
        return [this.fetchXAxis(), this.fetchYAxis()];
    };
    CategorySeries.vg = function (a, b, c, d, e) {
        var f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            var g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            var h = c.bottom + 10;
            var i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            var j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    };
    CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    CategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:wb:w7', [0, false], 'IsCustomCategoryStyleAllowed:wc:w8', [0, false], 'IsTransitionInEnabled:wd:w9', [0, false], 'TransitionInMode:vx:xa', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:wi:xb', [0, false]]);
    return CategorySeries;
}(MarkerSeries));
export { CategorySeries };
/**
 * @hidden
 */
var CategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeriesView, _super);
    function CategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cz = 0;
        _this.cu = null;
        _this.cx = null;
        _this.cz = -1;
        _this.cw = a;
        _this.cu = _this.cv();
        _this.cx = ((function () {
            var $ret = new Pool$1(Marker.$);
            $ret.create = runOn(_this, _this.b3);
            $ret.activate = runOn(_this, _this.cm);
            $ret.disactivate = runOn(_this, _this.co);
            $ret.destroy = runOn(_this, _this.cn);
            return $ret;
        })());
        return _this;
    }
    CategorySeriesView.prototype.cy = function (a) {
        if (this.cz != a.t) {
            return true;
        }
        return false;
    };
    CategorySeriesView.prototype.c1 = function (a) {
        this.cz = a.t;
    };
    CategorySeriesView.prototype.updateMarkerTemplate = function (a, b, c) {
        if (!this.b4.ue) {
            var d = this.cx.item(a);
            var e = d.content;
            e.item = this.e.c6.item(b);
            d.ak = b;
            d.al = c;
        }
    };
    CategorySeriesView.prototype.cv = function () {
        return new CategoryBucketCalculator(this);
    };
    Object.defineProperty(CategorySeriesView.prototype, "shouldDisplayMarkers", {
        get: function () {
            return this.cw.uc();
        },
        enumerable: false,
        configurable: true
    });
    CategorySeriesView.prototype.updateMarkerCount = function (a) {
        this.cx.count = a;
    };
    CategorySeriesView.prototype.ci = function (a) {
        this.cx.c(a);
    };
    CategorySeriesView.prototype.c0 = function () {
    };
    CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
}(MarkerSeriesView));
export { CategorySeriesView };
